// DTree.h: interface for the DTree class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DTREE_H__398FDFF1_E74C_419D_BE1F_DB81B05121DE__INCLUDED_)
#define AFX_DTREE_H__398FDFF1_E74C_419D_BE1F_DB81B05121DE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <fstream>
#include <math.h>
#include "DTNode.h"
using namespace std;
class DTree
{
	DTNode *root;
	DTree *l_child;
	DTree *r_child;
	int no_of_patterns;
	int no_of_attributes;
	int max_level;
	int no_of_nodes;
public:
	DTree(int, int, float**);
	~DTree();
	int get_no_of_nodes(){
		return no_of_nodes;
	}
	void set_no_of_nodes(int n){
		no_of_nodes = n;
	}
	int get_max_level(){
		return max_level;
	}
	void set_max_level(int l){
		max_level = l;
	}	
	DTNode* get_root(){
		return root;
	}
	DTree* get_l_child(){
		return l_child;
	}
	DTree* get_r_child(){
		return r_child;
	}
	void set_no_of_patterns(int i){
		no_of_patterns = i;
	}
	int get_no_of_patterns(){
		return no_of_patterns;
	}
	void set_no_of_attributes(int i){
		no_of_attributes = i;
	}
	
	int get_no_of_attributes(){
		return no_of_attributes;
	}

	DTNode* impure(DTNode*, double&, double&);
	void traverse(DTNode*, DTNode*,int&);
	void build(DTNode*, DTNode*, int);
	int follow(double*, int);
};

#endif // !defined(AFX_DTREE_H__398FDFF1_E74C_419D_BE1F_DB81B05121DE__INCLUDED_)
