#include <math.h>
#include <iostream>
#include <fstream>
#include <set>
#include "DTree.h"
using namespace std;

void main(int argc, char **argv){
	
	int patterns=0, attributes=0, i,j, set_0, set_1, set_0_0, set_0_1, set_1_0, set_1_1, best_attribute, best_set_0, best_set_1, best_set_0_0, best_set_1_0, best_set_0_1, best_set_1_1;
	char *filename, buff[100];
	float **elements, div_point,max_delta = -1, best_div_point;
	float **l_set, **r_set;
	float value,p_t_l, i_t_l, p_t_r, i_t_r, delta_i_s_t ;
	double p_0_given_t, p_1_given_t;
	double i_t;
	set<float> attribute_set;
	set<float>::iterator set_float_iter;
	DTNode *imp;
	if(argc != 2)
		cout << "input argument missing";
	filename = argv[1];
	ifstream input(filename);
	if(!input.is_open()){
		cout << "Error opening file" << endl;
	}
	while(!input.eof()){
		input.getline(buff, 100, '\t');
		if(patterns ==0)
			attributes++;

		if (buff[0] == 'x'){
			input.getline(buff, 100);
			patterns++;			
		}
		value = atof(buff);
		//cout << buff << endl;
	}
	attributes=attributes-1;
	elements = new float*[patterns];
	for(i=0; i<patterns; i++){
		elements[i] = new float[attributes];
	}

	input.close();
	ifstream input2(filename);
	if(!input2.is_open()){
		cout << "Error opening file" << endl;
	}

	for(i=0; i<patterns; i++){
		for(j=0; j<attributes; j++){

			input2.getline(buff, 100, '\t');

			elements[i][j] = atof(buff);
		}
		input2.getline(buff, 100);

	}
	input2.close();
	cout << patterns <<  " " << attributes << endl;
	DTree dt(patterns, attributes, elements);
	while (imp = dt.impure(dt.get_root(),p_0_given_t, p_1_given_t)){
		i_t = p_0_given_t*log(p_0_given_t)/log(2) + p_1_given_t*log(p_1_given_t)/log(2);
		i_t = i_t * -1;
		// imp is the pointer to the node that is impure
		// consider all the possible splits at this node
		// both in terms of the attribute and
		// the point split is made
		max_delta = -1;
		for(i=0; i<attributes-1; i++){
			// go over all the attributes
			attribute_set.clear();
			for(j=0; j<imp->get_no_of_patterns();j++){
				attribute_set.insert((imp->get_elements())[j][i]);
			} // this sorts the attributes
			// at this point we will consider each element
			// from the attribute_set as a possible split point
			// At each point, delta_i_s_t is found and compared
			// to the minimum. 
			for(set_float_iter=attribute_set.begin(); set_float_iter!=attribute_set.end(); set_float_iter++){
				set_0=0;
				set_1=0;
				set_0_0=0;
				set_0_1=0;
				set_1_0=0;
				set_1_1=0;
				div_point = *set_float_iter;
				for(j=0; j<imp->get_no_of_patterns(); j++){
					if((imp->get_elements())[j][i] <= div_point){
						set_0++;
						if((imp->get_elements())[j][attributes-1] == 0)
							set_0_0++;
						else
							set_0_1++;
					}else{
						set_1++;
						if((imp->get_elements())[j][attributes-1] == 0)
							set_1_0++;
						else
							set_1_1++;
					}
				}
				p_t_l = (float)set_0/patterns;
				p_t_r = (float)set_1/patterns;
				if(set_0 > 0){
					p_0_given_t = (float)set_0_0/set_0;
					p_1_given_t = (float)set_0_1/set_0;
				}else{
					p_0_given_t = 0;
					p_1_given_t = 0;
				}
				if(p_0_given_t != 0 && p_1_given_t !=0)
					i_t_l = p_0_given_t*log(p_0_given_t)/log(2) + p_1_given_t*log(p_1_given_t)/log(2);
				else if(p_0_given_t != 0 && p_1_given_t ==0)
					i_t_l = p_0_given_t*log(p_0_given_t)/log(2);
				else if(p_0_given_t == 0 && p_1_given_t !=0)
					i_t_l = p_1_given_t*log(p_1_given_t)/log(2);
				else
					i_t_l = 0;
				i_t_l *= -1;
				if(set_1 > 0){
					p_0_given_t = (float)set_1_0/set_1;
					p_1_given_t = (float)set_1_1/set_1;
				}else{
					p_0_given_t = 0;
					p_1_given_t = 0;
				}
				if(p_0_given_t != 0 && p_1_given_t !=0)
					i_t_r = p_0_given_t*log(p_0_given_t)/log(2) + p_1_given_t*log(p_1_given_t)/log(2);
				else if(p_0_given_t != 0 && p_1_given_t ==0)
					i_t_r = p_0_given_t*log(p_0_given_t)/log(2);
				else if(p_0_given_t == 0 && p_1_given_t !=0)
					i_t_r = p_1_given_t*log(p_1_given_t)/log(2);
				else
					i_t_r = 0;
				i_t_r *= -1;

				delta_i_s_t = i_t - p_t_l*i_t_l - p_t_r*i_t_r;
				if(delta_i_s_t > max_delta){
					max_delta = delta_i_s_t;
					best_div_point = div_point;
					best_attribute = i;
					best_set_0 = set_0;
					best_set_1 = set_1;
					best_set_0_0 = set_0_0;
					best_set_0_1 = set_0_1;
					best_set_1_0 = set_1_0;
					best_set_1_1 = set_1_1;
				}
			}
		}
		// now that we have found best attribute
		// and the best division point, we can make a split
		// based on the information we have found.
		l_set = new float* [best_set_0];
		r_set = new float* [best_set_1];

		set_0 = 0;
		set_1 = 0;
		for(i=0 ; i< imp->get_no_of_patterns(); i++){
			if((imp->get_elements())[i][best_attribute] <= best_div_point){
				// add it to l_set;
				l_set[set_0++] = (imp->get_elements())[i];
			}else{
				// add it to r_set;
				r_set[set_1++] = (imp->get_elements())[i];
			}
		}
		imp->set_leaf(false);
		imp->set_decision_attribute(best_attribute);
		imp->set_decision_point(best_div_point);
		imp->set_l_child(new DTNode(best_set_0, attributes, l_set,best_set_0_0>best_set_0_1?0:1,imp->get_level()+1));
		imp->set_r_child(new DTNode(best_set_1, attributes, r_set,best_set_1_0>best_set_1_1?0:1,imp->get_level()+1));
		if(imp->get_level()+1 > dt.get_max_level())
			dt.set_max_level(imp->get_level()+1);
		dt.set_no_of_nodes(dt.get_no_of_nodes() + 2);
		
	}
	int no_of_nodes;
	int ind =0 ;
	no_of_nodes = dt.get_no_of_nodes();
	fstream file("output.bin", ios::out|ios::binary);
	file.write((char*)&no_of_nodes, sizeof(int));
	DTNode* arr = new DTNode[no_of_nodes];
	for(i=0; i<no_of_nodes; i++){
		arr[i].set_decision_attribute(-1);
		arr[i].set_decision_point(-1);
		arr[i].set_decision(-1);
	}
	dt.traverse(dt.get_root(), arr, ind);
	int temp_int;
	float temp_float;
	for(i=0; i<no_of_nodes; i++){
		temp_int = arr[i].get_decision_attribute();
		file.write((char*)&temp_int, sizeof(int));
		temp_float = arr[i].get_decision_point();
		file.write((char*)&temp_float, sizeof(float));
		temp_int = arr[i].get_decision();
		file.write((char*)&temp_int, sizeof(int));
		temp_int = arr[i].get_l_c_index();
		file.write((char*)&temp_int, sizeof(int));
		temp_int = arr[i].get_r_c_index();
		file.write((char*)&temp_int, sizeof(int));

	}
	
	file.close();
}